"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Optional,
    Required,
    TypedDict,
    Union,
)

from pydantic import Field, StrictInt, StrictStr

from .. import DevopnessBaseModel
from .action_resource_data import ActionResourceData, ActionResourceDataPlain
from .resource_type import ResourceType, ResourceTypePlain


class ActionResource(DevopnessBaseModel):
    """
    ActionResource

    Attributes:
        id (int): The unique id of the resource
        type (ResourceType):
        type_human_readable (str): Human readable version of the resource type
        data (ActionResourceData, optional):
    """

    id: StrictInt = Field(description="The unique id of the resource")
    type: ResourceType
    type_human_readable: StrictStr = Field(
        description="Human readable version of the resource type"
    )
    data: Optional[ActionResourceData] = None


class ActionResourcePlain(TypedDict, total=False):
    """
    Plain version of ActionResource.
    """

    id: Required[int]
    type: Required[
        Union[
            ResourceType,
            ResourceTypePlain,
        ]
    ]
    type_human_readable: Required[str]
    data: Optional[
        Union[
            ActionResourceData,
            ActionResourceDataPlain,
        ]
    ]
