"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Required,
    TypedDict,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel


class CredentialAzure(DevopnessBaseModel):
    """
    CredentialAzure

    Attributes:
        tenant_id (str): ID that identifies your company space (directory) inside Azure
        subscription_id (str): ID that identifies your billing account where Azure resources are stored
        client_id (str): ID that identifies the application when connecting to Azure
        client_secret (str): Secret password used by the application to authenticate to Azure
    """

    tenant_id: StrictStr = Field(
        description="ID that identifies your company space (directory) inside Azure"
    )
    subscription_id: StrictStr = Field(
        description="ID that identifies your billing account where Azure resources are stored"
    )
    client_id: StrictStr = Field(
        description="ID that identifies the application when connecting to Azure"
    )
    client_secret: StrictStr = Field(
        description="Secret password used by the application to authenticate to Azure"
    )


class CredentialAzurePlain(TypedDict, total=False):
    """
    Plain version of CredentialAzure.
    """

    tenant_id: Required[str]
    subscription_id: Required[str]
    client_id: Required[str]
    client_secret: Required[str]
