"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Optional,
    Required,
    TypedDict,
    Union,
)

from pydantic import Field, StrictInt, StrictStr

from .. import DevopnessBaseModel
from .credential_input_settings import (
    CredentialInputSettings,
    CredentialInputSettingsPlain,
)


class CredentialUpdate(DevopnessBaseModel):
    """
    CredentialUpdate

    Attributes:
        id (int): The unique ID of the given Credential.
        name (str): The name of the credential. Must not be greater than 60 characters.
        settings (CredentialInputSettings, optional):
    """

    id: StrictInt = Field(description="The unique ID of the given Credential.")
    name: StrictStr = Field(
        description="The name of the credential. Must not be greater than 60 characters."
    )
    settings: Optional[CredentialInputSettings] = None


class CredentialUpdatePlain(TypedDict, total=False):
    """
    Plain version of CredentialUpdate.
    """

    id: Required[int]
    name: Required[str]
    settings: Optional[
        Union[
            CredentialInputSettings,
            CredentialInputSettingsPlain,
        ]
    ]
