"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Required,
    TypedDict,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel


class RepositoryRelation(DevopnessBaseModel):
    """
    RepositoryRelation

    Attributes:
        name (str): The name of the repository
        user_name (str): The name of the user/account on the Version Control System
        full_name (str): The fully qualified repository name. Usually composed of user_name/name
        html_url (str): The URL for viewing repository details on the provider&#39;s web application
    """

    name: StrictStr = Field(description="The name of the repository")
    user_name: StrictStr = Field(
        description="The name of the user/account on the Version Control System"
    )
    full_name: StrictStr = Field(
        description="The fully qualified repository name. Usually composed of user_name/name"
    )
    html_url: StrictStr = Field(
        description="The URL for viewing repository details on the provider's web application"
    )


class RepositoryRelationPlain(TypedDict, total=False):
    """
    Plain version of RepositoryRelation.
    """

    name: Required[str]
    user_name: Required[str]
    full_name: Required[str]
    html_url: Required[str]
