"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    List,
    Optional,
    Required,
    TypedDict,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel


class RoleProjectCreate(DevopnessBaseModel):
    """
    RoleProjectCreate

    Attributes:
        name (str): The role&#39;s name. Must be at least 2 characters. Must not be greater than 60 characters.
        description (str, optional): Description of this role. Must not be greater than 255 characters.
        permissions (List[str]): The list of permissions granted for this role
    """

    name: StrictStr = Field(
        description="The role's name. Must be at least 2 characters. Must not be greater than 60 characters."
    )
    description: Optional[StrictStr] = Field(
        default=None,
        description="Description of this role. Must not be greater than 255 characters.",
    )
    permissions: List[StrictStr] = Field(
        description="The list of permissions granted for this role"
    )


class RoleProjectCreatePlain(TypedDict, total=False):
    """
    Plain version of RoleProjectCreate.
    """

    name: Required[str]
    description: Optional[str]
    permissions: Required[List[str]]
